#pragma once

#include <vector>
#include "RtMidi.h"
#include "Message.h"

namespace midi {

class Input : public RtMidiIn
{
public:
	typedef void (*MessageInCallback)( double timeStamp, Message &message, void *userData );
	void setCallback( MessageInCallback callback, void *userData = 0 );

protected:
	MessageInCallback userCallback;
    void *userCallbackData;

private:
	static void rtmidiCallback( double timeStamp, std::vector<unsigned char> *message, void *midiin );
};

} // namespace midi
